datablock AudioDescription(AvpingExt3d)
{
   volume   = 1;
   isLooping= false;
   is3D     = true;
   ReferenceDistance= 100.0;
   MaxDistance= 100.0;
   type     = $SimAudioType;
};
datablock AudioProfile(AvSubSound)
{
   filename    = "./sub.wav";
   description = AvpingExt3d;
   preload = true;
};
datablock ShapeBaseImageData(AviatorSubProp)
{
   shapeFile = "./shapes/prop.dts";
	emap = false;

	mountPoint = 1;
   rotation = "1 0 0 0";
   
   	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;
	
	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "FireE";
	stateWaitForTimeout[1]			= true;
	stateEmitter[1]					= rocketLauncherSmokeEmitter;
	stateEmitterTime[1]				= 1;
	stateEmitterNode[1]				= "mountpoint";
	stateSequence[1]				= "prop";
	stateTimeoutValue[1]			= 0.2;
	
	stateName[2]					= "FireE";
	stateTransitionOnTimeout[2]		= "FireA";
	stateWaitForTimeout[2]			= true;
	stateSequence[2]				= "prop";
	stateTimeoutValue[2]			= 0.2;
	
};
datablock ShapeBaseImageData(AviatorSubPropF)
{
	shapeFile = "./shapes/prop.dts";
	emap = false;

	mountPoint = 1;
	rotation = "0 1 0 0 ";
};
datablock WheeledVehicleData(AviatorSubVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./shapes/AviatorSub.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "sit";


	maxDamage = 200.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 30;         // Far distance from vehicle
	cameraOffset = 3;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.0;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = true;	

	defaultTire	= "";
	defaultSpring	= "";
	//flatTire	= jeepFlatTire;
	//flatSpring	= jeepFlatSpring;

   numWheels = 0;

	mass = 500;
	density = 1;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 30;        // Engine scale by current speed / max speed

	rollForce		= 100000;
	yawForce		= 900000;
	pitchForce		= 600000;
	rotationalDrag		= 0.2;
   forwardThrust		= 6000;
	reverseThrust		= 2000;
	lift			= 0;
	maxForwardVel		= 30;
	maxReverseVel		= 30;//2
	horizontalSurfaceForce	= 200;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 200; 
stallSpeed		= 0;
   // Advanced Steering
   steeringAutoReturn = false;
	    steeringUseStrafeSteering = false;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Aviator Sub ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = jeepExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = jeepFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = false;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
   heightcontrol= 1;		//Enables the heightcontrol support for this vehicle
	ascendVelocity= 1.8;	//The velocity it adds when a user presses/holds the jumpkey
	descendVelocity= -2.8;	//The velocity it extracts when a user presses/holds the jumpkey
};
function AviatorSubVehicle::onAdd(%this,%obj)
{
	%obj.mountimage(AviatorSubPropf,1);
	AviatorSubSpeedCheck(%this,%obj);
	%obj.ping = 0;
	%obj.depthlock = false;
}
function AviatorSubSpeedCheck(%this, %obj)
{	
	if(!isObject(%obj))
		return;
	%vehicle = %obj;
	%waterlevel = getword(water.gettransform(),2)+getword(water.getscale(),2);
	//echo(%waterlevel SPC getword(%obj.getposition(),2));
	%Vel = %obj.getvelocity();
	%trans = %obj.getTransform();
	%pos = %obj.getposition();
	if(getword(%obj.getposition(),2) > %waterlevel && %obj.depthlock==false)
	{
	
	%obj.setvelocity(vectorAdd(%obj.getVelocity(),vectorscale("0 0 -0.5",(getword(%obj.getposition(),2)-%waterlevel)*2)));
	}
	%obj.depth = mFloor(%waterlevel-getword(%obj.getposition(),2)+0.5);
	
	if(%obj.depthlock==true)
	{
		if(!%obj.lTrans || %obj.lTrans==0)
			%obj.lTrans=getword(%obj.getTransform(),2);
		
		if(getword(%pos,2) > %obj.lTrans)
		%obj.setvelocity(getwords(%vel,0,1) SPC "-1");
		else if(getword(%pos,2) < %obj.lTrans)
		%obj.setvelocity(getwords(%vel,0,1) SPC "1");
	}
	else
	{
	%obj.lTrans=0;
	}
	
	if(mfloor(getword(%vel,2)+0.5) > 0)
	{
		%sign = "+";
	}
	else
	{
		%sign = "-";
	}
	
	commandToClient(%obj.getMountedObject(0).client,'bottomprint',
	"<just:left><font:Impact:24pt>\c3Depth <font:Impact:24pt>\c6: " @ %sign @ %obj.depth @ 
	"<just:Right><font:Impact:24pt>\c3Depth Lock <font:Impact:24pt>\c6: " @ %obj.depthlock , 1, 2, 3, 4);
	
	if(isobject(%obj.getmountedobject(0)))
	{
		
		if(%obj.ping == 300)
		{
			serverPlay3d(AvSubSound,%obj.getposition());
			
			%obj.ping = 0;
		}
		else
			%obj.ping++;
	}
	
	
	schedule(10,0,"AviatorSubSpeedCheck",%this,%obj);
}
function AviatorSubVehicle::onDriverLeave(%this,%obj)
{
	%obj.unmountimage(1);
	%obj.mountimage(AviatorSubPropf,1);
	
}
package AviatorSub
{
	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if(%col.getDataBlock() == AviatorSubVehicle.getId())
		{
			%col.mountimage(AviatorSubProp, 1);
		}

	}
	function servercmdLight(%client)
	{

	
		%p = %client.player;
		if(!isobject(%p.getobjectmount()))
			return Parent::servercmdLight(%client);

		%obj = %p.getobjectmount();

		if(%obj.getdatablock() == AviatorSubvehicle.getid())
		{
			
			if(%obj.depthlock==true)
			%obj.depthlock=false;
			else
			%obj.depthlock=true;
			
			//echo(%obj.depthlock);
		}
		else
		Parent::servercmdLight(%client);
							
			
	}
};
activatePackage(AviatorSub);